;##_La chasse à la liberté_##
;...parce que:
;"Or, sous tous les cieux sans vergogne,
;	C'est un usage bien établi,
;	Dès qu'il s'agit de rosser les cognes
;	Tout le monde se réconcilie."
; -_^

;Chaque fois que j'apprends qu'un artiste que j'aime, qu'un écrivain
;	que j'admire viennent d'être décorés, j'éprouve un sentiment pénible,
;	et je me dis aussitôt : Quel dommage !
;-Octave Mirbeau
;
;no estoy de acuerdo en absoluto con el maltrato de animales,
;	es por eso que este juego no se trata de golpear a los
;	pobres topos que no han hecho más que levantar la cabecita
;	para ver y explorar este hermoso mundo que nos rodea, más bien
;	se trata de arremeter contra algo que realmente nos hace daño!
;je ne suis pas d'accord avec le mauvais traitement d'animaux,
;	c'est pour ça qu'ici l'on va pas tuer des taupes !
;i'm against the mistreatment of animals, which is why i refuse
;	to use moles in this game


;[##########################################]
;[### ce code est dans le domaine public ###]
;[## mort au copyright, vive le plagiat ! ##]
;[##########################################]

#include "ti83plus.inc"

grupo1	= $FE				;las flechas
grupo2	= $FD
diClear	= 191
grupo3	= $FB
di3		= 253 
di6		= 251 
di9		= 247 
grupo4	= $F7
di2		= 253 
di5		= 251
di8		= 247
grupo5	= $EF
di0		= 254 
di1		= 253
di4		= 251
di7		= 247
grupo7	= $BF
di2nd	= 223


gbuf	=$9340

saferam1= $86EC			;saveSScreen=768

;adición 24 bit
.addinstr add ahl,de	00CE19	3 NOP 1	;add hl,de \ adc a,0	;3 bytes
.addinstr add ahl,bc	00CE09	3 NOP 1	;add hl,bc \ adc a,0
.addinstr add ahl,cde	8919	2 NOP 1	;add hl,de \ adc a,c	;2 bytes
.addinstr add ahl,bde	8819	2 NOP 1	;add hl,de \ adc a,b
.addinstr add ahl,ebc	8309	2 NOP 1	;add hl,bc \ adc a,e
.addinstr add ahl,dbc	8209	2 NOP 1	;add hl,bc \ adc a,d

;substracción 24 bit
.addinstr sub ahl,cde	52ED91	3 NOP 1		;sub c \ sbc hl,de		;3 bytes
.addinstr sbc ahl,bde	9852ED	3 NOP 1		;sbc hl,de \ sbc a,b	;3 bytes
.addinstr sbc ahl,de	00DE52ED	4 NOP 1 ;sbc hl,de \ sbc a,0	;4 bytes


;VARIABLES Y TABLAS
counter		= saferam1			;0
jugadorX	= counter+1			;1
jugadorYOff	= jugadorX+1		;2
jugadorY	= jugadorYOff+1		;3
jugadorYVel	= jugadorY+1		;4
jugadorYFrac= jugadorYVel+1		;5 fracción de la velocidad
jugadorDir	= jugadorYFrac+1	;6
jugadorMov	= jugadorDir+1		;7 si el jugador ha movido a la derecha/izquierda
jugAnimCont	= jugadorMov+1		;8
jugSalto	= jugAnimCont+1		;9
mapa		= jugSalto+1		;10
mapaAltura	= mapa+2			;11
nivelActual	= mapaAltura+1		;13
puntos		= nivelActual+1		;14 puntos totales
meterPuntos	= puntos+3			;15 cuando se añaden puntos, se los mete en este variable
tiempo		= meterPuntos+2		;18 el tiempo que queda para completar el nivel
saltoPulsado= tiempo+2			;20
flechas		= saltoPulsado+1	;22 las flechas actualmente pulsadas
muerte		= flechas+1			;23
muerteAnim	= muerte+1

tablaDeCabezas = saferam1+30	;cada entrada tiene dos bytes, el primero es el estado, el segundo es un contador
table = tablaDeCabezas+18		;donde se copia el texto de la introducción
teclaPulsada = table+10			;la tecla actualmente registrada como pulsada
tablaDeTeclas = teclaPulsada+1	;9 bytes una lista de las teclas pulsadas
tablaDeBalas = tablaDeTeclas+9	;las balas que disparan las cabezas de mierda
								;encendido/apagado,x,yvel,yoff,y [5 bytes]
sangre = tablaDeBalas

;CONSTANTES
MESA_ANCHO = 6					;cuanto la mesa tiene de ancho
MESA_X = 6

.db $BB,$6D
.org $9D95

principio:
	di
	call limpiarVariables
	call introduccion
	call titulo
	res textInverse, (iy+textFlags) 
	jp soltarTeclas

nuevaPartida:
	bcall(_GrBufClr)
	call limpiarVariables
	call cargarNivel
main:
	ld a,(tiempo+1)
	or a
	 jp z,hasMuerto		;has perdido!
	call dibMapa
	call dibMesa
	call dibPuntos		;los puntos ganados
	call dibTiempo		;el tiempo que queda
	call llenarMesa
	call anadirCara		;aleatoriamente añadir una guardia
	call dibJugador
	call buscarAcciones	;si la baldosa tiene alguna acción especial
	ld hl,muerte
	ld a,(hl)
	or a
	push af
	 call nz,dibSangre
	pop af
	 call z,dibBalas
	call gbufCopy
;¡atacar a las guardias!
	call leerNumeros
;si quieres salir o no
	call leerClear
	 jp z,titulo		;volver al título
;saltar (0, 2nd o Arriba)
	ld hl,saltoPulsado
	ld (hl),0
	call leer2nd
	 call z,saltar
	ld a,grupo5
	out (1),a
	in a,(1)
	rra
	 call nc,saltar
;ahora las flechas
	ld a,$FF	;limpiar el puerto
 	out (1),a	
	call leerFlechas
	rra			;[abajo]
	 jr nc,saltarAGravedad	;no se puede mover si se está agachando
	ld hl,jugadorMov		;borrar el valor
	ld (hl),0
	rra
	push af
	push hl
	 call nc,haciaIzquierda
	pop hl
	pop af
	rra
	push af
	 call nc,haciaDerecha
	pop af
	rra
	 ld hl,saltoPulsado
	 call nc,saltar
saltarAGravedad:
	call gravedad
	jr main

;limpiar tabla y variables
limpiarVariables:
	ld bc,256
	ld hl,counter
	ld (hl),c
	ld de,counter+1
	ldir
	ld hl,mapaYOff
	ld (hl),c
	ret

esperarTecla:
	xor a
	out (1),a
		in a,(1)
		inc a
		 ret nz
		jr $-4

soltarTeclas:
	xor a
	out (1),a	;escanear el grupo 1, que contiene las flechas
	in a,(1)	;(abajo = %11111110, izquierda = %11111101, derecha = %11111011, arriba = %11110111)
	inc a
	 ret z
	jr soltarTeclas

leerClear:
	ld a,grupo2
	out (1),a
	in a,(1)
	cp diClear
	ret

leerFlechas:
	ld a,grupo1
	out (1),a	;escanear el grupo 1, que contiene las flechas
	in a,(1)	;(abajo = %11111110, izquierda = %11111101, derecha = %11111011, arriba = %11110111)
	ld (flechas),a
	ret

leerNumeros:
	ld hl,tablaDeTeclas+8
	ld c,grupo3		;9 6 3
	call leerTeclado
	ld c,grupo4		;8 5 2
	call leerTeclado
	ld c,grupo5		;7 4 1
	call leerTeclado
;ahora a procesar lo que hemos leído del teclado!
	ld hl,teclaPulsada
	ld c,(hl)
	ld b,0
	add hl,bc		;tablaDeTeclas viene justo después de teclaPulsada, si teclaPulsada = 1
	ld a,(hl)		;...teclaPulsada+1 = el primer byte de la tabla
	or a
	 ret nz
	sbc hl,bc		;si esa tecla ya no está pulsada
	ld (hl),0		;borrarla de teclaPulsada

	ld c,9
	xor a
	ld de,tablaDeTeclas+8
teclaBucle:
	ld a,(de)
	or a
	 jr nz,$+5		;salir del bucle
	dec de
	dec c
	 jr nz,teclaBucle
	ld (hl),c
	dec c
	 ret m
	ld hl,tablaDeCabezas
	add hl,bc
	add hl,bc		;cada entrada ocupa 2 bytes
	ld a,(hl)
	or a
	 jr nz,borrarCara
		ld hl,tiempo+1
		ld a,(hl)
		sub 2
		ld (hl),a
		 ret nc
		ld (hl),0
		ret
borrarCara
	xor a
	ld (hl),a		;borrar la cara
	inc hl
	ld (hl),a
	ld c,5
	ld hl,(meterPuntos)
	add hl,bc
	ld (meterPuntos),hl
	ret

leerTeclado:
	ld a,$FF		;limpiar teclado
	out (1),a
	ld a,c
	out (1),a
	in a,(1)
	rra
	and %00000111

	ld b,3			;procesar 3 teclas
	ld de,3		;cada tecla es separada por tres (1, 4, 7; 2, 5, 8)
leerTecladoBucle:
	rra
	ld (hl),d		;0 (tecla no pulsada)
	 jr c,$+3
		inc (hl)	;1 (tecla pulsada)
	or a
	sbc hl,de		;+3 (ver explicación arriba)
	djnz leerTecladoBucle
	ld e,8
	add hl,de		;listo para procesar el próximo grupo!
	ret

leer2nd:
	ld a,grupo7
	out (1),a
	in a,(1)
	cp di2nd
	ret

;número aleatorio en a
aleatorio:
	push hl
		inc b
		ld a,r
semilla = $+1
		ld hl,0000
		adc a,l
		ld h,a
		ld a,(hl)
		xor l				;jugando con el número :)
		ld e,a
		sbc hl,hl
		ld d,h
randomBoucle:
		add hl,de			;rotamos el número en e dans h
		djnz randomBoucle	;b*e (e = 0/256 - 255/256)
		ld a,h
		ld (semilla),hl
	pop hl
	ret 


;-----> Copy the gbuf to the screen (fast)
;primero dibujamos la parte izquierda de la pantalla con un offset Y
;después la parte derecha sin ningún offset
gbufCopy:
	di
	ld a,$80
	out ($10),a
	ld hl,gbuf-12-(-(12*64)+1)-12
	ld a,$20
	ld c,a
mapaYOff = $+1
	ld b,0
	inc b
		ld de,12
		add hl,de
	 djnz $-4
gbufCopyAgain:
	ld b,64
	inc c
	ld de,-(12*64)+1
	out ($10),a
	add hl,de
	ld de,10
gbufCopyLoop:
	add hl,de
	inc hl
	inc hl
	inc de
	ld a,(hl)
	out ($11),a
	dec de
	djnz gbufCopyLoop
	ld a,c
	cp $26
	 jr nz,$+5
		ld hl,gbuf-12-(-(12*64)+1)+6
	cp $2B+1
	 jr nz,gbufCopyAgain
	ret

#include "CHASSE28_balas.asm"
#include "CHASSE28_intro.asm"
#include "CHASSE28_mapa.asm"
#include "CHASSE28_mesa.asm"
#include "CHASSE28_sprite.asm"
#include "CHASSE28_texto.asm"
#include "CHASSE28_titulo.asm"

jugador:
#include "sprites/persCam0.bmp"	;personaje caminando frame 0
#include "sprites/persCam1.bmp"
#include "sprites/persCam2.bmp"
#include "sprites/persSal.bmp"
#include "sprites/persAgach.bmp"
jugadorD:
#include "sprites/persCam0D.bmp";personaje caminando hacia la derechaframe 0
#include "sprites/persCam1D.bmp"
#include "sprites/persCam2D.bmp"
#include "sprites/persSalD.bmp"
#include "sprites/persAgachD.bmp"
rejas:
#include "sprites/rejas1.bmp"
#include "sprites/rejas2.bmp"
pistola:
#include "sprites/pistola1.bmp"
#include "sprites/pistola2.bmp"
bala:
.db %11100000
.db %11100000

brush_tabla:
.db brush0-brush_data
.db brush1-brush_data
.db brush2-brush_data
.db brush3-brush_data
.db brush4-brush_data
.db brush5-brush_data
.db brush6-brush_data
.db brush7-brush_data
.db brush8-brush_data
.db brush9-brush_data
.db brush10-brush_data

;.db brush10-brush_data


brush_data:
;byte de acción:
;0: se puede pasar desde abajo, armado = no
;1: se puede pasar desde arriba, armado = no
;2: se puede pasar desde la izquierda, armado = no
;3: se puede pasar desde la derecha, armado = no
;4: avanzarte al próximo nivel una vez dentro
brush0:
.db 0
.db %00000000
brush1:			;*plataforma*
.db 1
.db %00000010	;no se puede pasar desde arriba
brush2:			;*rejas*
.db 2
.db %00000001	;no se puede pasar desde abajo
brush3:			;*rejas arriba*
.db 3
.db %00001111	;no se puede pasar!
brush4:			;*techo*
.db 1
.db %00000001
brush5:			;*rejas fin*
.db 4
.db %00001111	;no se puede pasar
brush6:			;*curva derecha*
.db 5
.db %00000110
brush7:			;*punta derecha plataforma*
.db 6
.db %00000000
brush8:			;*puerta arriba*
.db 7
.db %00000010
brush9:			;*puerta debajo avanzar*
.db 8
.db %00010001	;avanzar al próximo nivel
brush10:		;*puerta debajo nada*
.db 8
.db %00000001

sprite_data:
.dw $0000 \ .dw $0000 \ .dw $0000 \ .dw $0000 ;0
#include "baldosas/tile1.bmp"	;1
#include "baldosas/tile2.bmp"	;2
#include "baldosas/tile3.bmp"	;3
#include "baldosas/tile4.bmp"	;4
#include "baldosas/tile5.bmp"	;5
#include "baldosas/tile6.bmp"	;6
#include "baldosas/tile7.bmp"	;7
#include "baldosas/tile8.bmp"	;8

numeros:
#include "num_pal/0.bmp"		;0
#include "num_pal/1.bmp"		;1
#include "num_pal/2.bmp"		;2
#include "num_pal/3.bmp"		;3
#include "num_pal/4.bmp"		;4
#include "num_pal/5.bmp"		;5
#include "num_pal/6.bmp"		;6
#include "num_pal/7.bmp"		;7
#include "num_pal/8.bmp"		;8
#include "num_pal/9.bmp"		;9

nivelSprite:
#include "num_pal/nivel.bmp"	;nv:
puntosSprite:
#include "num_pal/puntos.bmp"	;pts:
tiempoSprite:
#include "num_pal/tiempo.bmp"	;pts:

cabeza_de_mierda:
#include "sprites/cabeza_de_mierda.bmp"

texto:
.db "Now i know why i am",0
.db "where i am, why they lock",0
.db "me away and hide me.",0,0

;.db "Now i know why so many die",0
;.db "disconnected from it all,",0
;.db "why others live in terror,",0
;.db "why they've created",0
;.db "this system that so",0
;.db "closely resembles an",0
;.db "advertisement.",0,0
;.db "Now i know that nothing",0
;.db "is like they tell us,",0
;.db "that everything is",0
;.db "discovered through our",0
;.db "own gaze, that the TRUTH",0
;.db "(in capital letters),",0
;.db "is nothing more than a",0
;.db "tall tale.",0,0
;.db "Now i know that i'll never",0
;.db "bow my head,",0
;.db "that i'll never say",0
;.db "like an ass \"yes sir\",",0
;.db "that i'll only speak",0
;.db "with my equals as we",0
;.db "convert life into a revolt",0
;.db "of love...",0,0
;.db "Now i know why things are",0
;.db "as they are, and why i",0
;.db "am the way i am.",0,0
.db "-Gabriel Pombo da Silva",0,$FF

menu:
.dw jugarTxt
.dw acercaTxt
.dw salirTxt

liberteTxt:
.db "La chasse a la liberte",0
highScoreTxt:
.db "Punt. Alta:",0
jugarTxt:
.db "Jugar",0
acercaTxt:
.db "...",0
salirTxt:
.db "Fugar",0

nivelCompletadoTxt:
.db "Nivel terminado!",0
.db "Tiempo restante:",0
puntosTxt:
.db "Puntos totales:",0

muertoTxt:
.db "Has muerto luchando",0
.db "por tu libertad",0
;.db "Te han abatido!",0

highScoreTxt2:
.db "Nueva puntuacion alta!",0

highScore:
.db 0,0,0

#include "CHASSE28_mapas.inc"
