;“There’s no such thing as a wrong war. Violence and revolution are the only pure acts.”
;-Mick (If....)

dibJugador:
	ld ix,jugador
	ld hl,jugadorDir		;dónde está mirando?
	ld a,(hl)
	or a
	 jr z,$+6
		ld ix,jugadorD
	ld d,0
	ld a,(jugadorYVel)
	or a
	 jr z,jugadorCaminar
		ld e,12*3
		add ix,de
		jr saltarAnimacion
jugadorCaminar:
	ld a,(flechas)			;vamos a ver si la flecha de abajo se está pulsando
	rra
	 jr c,$+8
		ld e,12*4
		add ix,de
		jr saltarAnimacion
	inc hl					;jugadorMov
	ld a,(hl)
	or a
	 jr z,saltarAnimacion
		ld e,12			;tamaño de los sprites
		ld hl,jugAnimCont	;contador para la animación del jugador
		inc (hl)
		ld a,(hl)
		bit 3,a
		 jr z,saltarAnimacion
			add ix,de
		bit 4,a
		 jr z,saltarAnimacion
			add ix,de
saltarAnimacion:
	ld hl,mapaY
	ld a,(jugadorY)
	sub (hl)			;jugadorY - mapaY
	add a,a
	add a,a
	add a,a				;*8, convertir en píxeles
;	ld hl,mapaYOff
;	sub (hl)
	ld hl,jugadorYOff
	add a,(hl)
	ld e,a				;e = coordenada Y
	ld a,(jugadorX)
;a = x
;e = y
;ix = sprite
;(b = altura del sprite)
dibSprite:
	ld b,12				;altura del sprite
dibSprite_var:
	ld h,0
	ld d,h				;d & h = 0
;clipping Y
	ex af,af'			;guardar a (coordenada X)
		ld a,b			;altura del sprite
		add a,e			;altura + coordenada Y
		 ret m			;si negativo, el sprite está fuera de la pantalla
		 ret z
		 jr nc,$+11		;nc lugar Y es positivo
			ld b,a		;b = cuantas filas del sprite que vamos a dibujar
			ld a,e
			neg
			ld e,a
			add ix,de
			xor a
			ld e,a		;nueva coordenada Y
		cp 72			;ahora a ver si la coordenada Y pasa de 64
		 jr c,$+8
			ld a,72
			sub e
			 ret c
			 ret z
			ld b,a
	ex af,af'			;coordenada X

;y*12
	ld l,e
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, hl			;x12

;x/8
	ld	e, a
	srl e
	srl e
	srl e
	add	hl,de			;
	ld de,gbuf			;
	add	hl,de			;

	and $07				;el offset X
	ld c,a				;c = offset X
	ld de,11
dibSpriteBucle:
	push	bc
	ld	b, c			;b = offset X
	ld	a, (ix)			;a = byte del sprite
	inc	ix				;
	ld	c, d			;c = 0
	dec b				;si b = 0
	inc b				;...
	 jr z,$+2+1+2+2		;no rotar el sprite
dibSpriteshiftBucle:
;carry = 0 (por el "inc ix")
	 rra				;
	 rr	c				;
	 djnz	dibSpriteshiftBucle
OR_XOR1 = $
	or	(hl)
	ld	(hl), a			;
	inc	hl				;
	ld	a, c			;
OR_XOR2 = $
	or	(hl)			;
	ld	(hl), a 		;
	add	hl, de 			;
	pop	bc
	djnz dibSpriteBucle
	ret

fijarXOR:
	ld a,$AE				;xor (hl)
	jr cargarORXOR
fijarOR:
	ld a,$B6				;or (hl)
cargarORXOR:
	ld (OR_XOR1),a
	ld (OR_XOR2),a			;devolverla a or
	xor a
	ld (mapaYOff),a
	ret
