;Der Haß meiner Feinde darf als Bürgschaft gelten, daß ich dieses Amt bisher recht treu
;	und ehrlich verwaltet. Ich werde mich jenes Hasses immer würdig zeigen.
;-Heinrich Heine

dibTiempoPuntos:
	ld hl,gbuf+(26*12)+8
	call borrarBloque
	ld hl,gbuf+($22*12)+7
	call borrarBloque
	ld hl,gbuf+($22*12)+9
	call borrarBloque

	ld de,$1A3C
	call dibTiempo_var
	ld de,$2235
	call dibPuntos_var
	jp gbufCopy

borrarBloque:
	ld bc,$0B
	ld a,4
	ld (hl),$FF
	inc hl
	ld (hl),$FF
	add hl,bc
	dec a
	 jr nz,$-7
	ret

avanzarNivel:
	call soltarTeclas
;convertir la rutina de sprite en xor
	call fijarXOR
;fijar mapaYOff a cero
;	xor a
;	ld (mapaYOff),a
;dibujar los textos
	call gbufNegro
	ld hl,nivelCompletadoTxt
	ld de,$1005
	ld (penCol),de
	bcall(_VPutS)

	ld de,$1805
	ld (penCol),de
	bcall(_VPutS)

	ld de,$2005
	ld (penCol),de
	bcall(_VPutS)

	call dibTiempoPuntos
	call esperarTecla
	call soltarTeclas

	xor a
	out (1),a
tiempo_puntos_bucle:
	in a,(1)
	inc a
	 jr nz,salirTPBucle
	call dibTiempoPuntos
	ld hl,(meterPuntos)
	ld a,l
	or h
	 jr nz,tiempo_puntos_bucle
	ld l,10
	ld (meterPuntos),hl
	ld hl,tiempo+1
	dec (hl)
	 jr nz,tiempo_puntos_bucle
salirTPBucle:
	ld hl,tiempo+1
	ld c,(hl)
	xor a
	ld (hl),a
	ld b,a
	ld l,c
	ld h,b
	add hl,hl
	add hl,hl
	add hl,bc
	add hl,hl					;tiempo*10
	ld bc,(meterPuntos)
	add hl,bc					;+puntos que falta añadir
	ld bc,(puntos)
	add hl,bc
	ld (puntos),hl
	ld a,(puntos+2)
	adc a,0
	ld (puntos+2),a
	ld hl,0
	ld (meterPuntos),hl
	call dibTiempoPuntos
	call soltarTeclas

	call esperarTecla
	call soltarTeclas

	call fijarOR			;devolver rutina de sprite a OR
;ahora cargar el próximo nivel
cargarNivel:
	ld hl,tablaDeCabezas
	ld (hl),0
	ld de,tablaDeCabezas+1
	ld bc,17
	ldir

	ld hl,nivelActual
	ld a,(hl)
	inc (hl)
	cp 3
	 jp z,hasMuerto	;no hay espacio para ganar
	add a,a
	ld e,a
	ld d,0
	ld hl,lista_de_mapas
	add hl,de		;offset en la lista de mapas (según el nivel actual)
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a			;ld hl,(hl)

	ld d,(hl)
	ld e,0
	ld (tiempo),de
	inc hl

	ld de,jugadorX
	ldi				;jugadorX
	ld a,4
	ld (de),a		;jugadorYOff
	inc de
	ldi				;jugadorY
	ld a,(hl)
	ld (mapaAltura),a
	inc hl
	ld (mapa),hl
	ld hl,mapaY
	ld b,a			;b = altura del mapa
	ld a,(jugadorY)
	sub 4
	ld (hl),a
	 jr nc,$+4
	 	ld b,0
	cp b
	 jp c,dibNivel
	ld (hl),b
	bcall(_GrBufClr)
	jp dibNivel

haciaIzquierda:
	inc (hl)
	dec hl			;jugadorDir
	ld (hl),0

	ld b,-1
	call verColisionX
	bit 2,a				;bit 2 = el bit de colisiones
	 ret nz

	ld hl,jugadorX
	ld a,(hl)
	or a
	 ret z
	dec (hl)
	ret

haciaDerecha:
	inc (hl)		;para reconocer que el sprite se mueve
	dec hl			;jugadorDir
	ld (hl),1		;1 = hacia la derecha

	ld b,8
	call verColisionX
	bit 3,a				;bit 3 = el bit de colisiones hacia la derecha
	 ret nz

	ld hl,jugadorX
	ld a,(hl)
	cp 5*8
	 ret z
	inc (hl)
	ret

;hl = saltoPulsado
saltar:
	inc (hl)
	ld hl,jugSalto
	ld a,(hl)
	or a
	 ret nz
	inc (hl)
	ld hl,jugadorYVel
	ld a,(hl)
	or a
	 ret nz
	ld (hl),16
	ret

gravedad:
;vamos para arriba o para abajo?
	ld hl,jugadorYVel
	ld a,(hl)
	dec a
	 jp p,haciaArriba
	dec (hl)
	cp -20
	 jr nz,$+3
		inc (hl)
	inc hl
	add a,(hl)
	ld b,0
	 jr z,saltarFrac
	dec b
	inc b
	add a,4
	 jr nc,$-3
	sub 4
	ld (hl),a
saltarFrac:
	ld a,(jugadorYOff)
	push bc
		add a,b
		add a,12
		call aDiv8			;a/8
		call verColisionY
		ld hl,jugSalto
		or c				;combinar a y c
		bit 1,a				;si bit 1 de a o c está armado
	pop bc					;...
	 jr z,gravedadPasar		;no se puede pasar
		ld (hl),-1			;jugSalto = 0 significa que podemos saltar de nuevo (más abajo hay un "inc (hl)")
		ld de,0
		ld (jugadorYVel),de	;devolver la velocidad Y/fracción a cero
		ld a,(jugadorYOff)
		add a,4
		ld b,a
		ld a,8
		sub b
		ld b,a
gravedadPasar:
	inc (hl)				;no estamos en tierra, así que no podemos saltar

	ld hl,jugadorYOff
	ld a,(hl)
	add a,b
	ld (hl),a
	sub 8
	 jr c,gravedadMapa
	ld (hl),a
	inc hl				;jugadorY
	inc (hl)
gravedadMapa:
;ver si hay que desplazar el mapa
;comprobar posición del jugador
	ld hl,jugadorY
	ld de,mapaY
	ld a,(de)
	dec a
	sub (hl)			;mapaY-jugadorY
	cp -3
	 ret nc
;mapaAltura = mapaY ?
	call verifMapaFin
	 ret z
	ld a,(hl)
	add a,b
	ld (hl),a
	sub 8
	 ret c
	ld (hl),a
	ex de,hl
	inc (hl)
	ex de,hl
verifMapaFin:
	ld hl,mapaAltura
	ld a,(de)			;ld a,(mapaY)
	cp (hl)
	ld hl,mapaYOff
	 ret nz
	ld (hl),0
	ret

haciaArriba:
	ld a,(saltoPulsado)
	or a
	 jr nz,$+11
		ld hl,$0000
		ld (jugadorYVel),hl	;vel Y y fracción Y = 0
		jp gravedad
	ld hl,jugadorYVel
	ld a,(hl)
	dec (hl)
	ld hl,jugadorYFrac		;esta fracción se convierte en la cantidad de pixeles que vamos a avanzar
	add a,(hl)
	ld b,$FF
	inc b
	sub 4					;fracción Y/4
	 jr nc,$-3
	add a,4
	ld (hl),a				;guardar el resto
	push bc
		ld a,(jugadorYOff)
		sub b
		ld a,-1				;la baldosa de arriba
		 jr c,$+3
			inc a
		call verColisionY
		or c
		rra
	pop bc
	 jr nc,$+9
	 	ld hl,$0000
		ld hl,(jugadorYVel)	;actualizar jugadorYVel y jugadorYFrac
		ret
	ld hl,jugadorYOff
	ld a,(hl)
	sub b
	ld (hl),a
	 jr nc,haciaArribaMapa
	add a,8
	ld (hl),a
	inc hl				;jugadorY
	dec (hl)
haciaArribaMapa:
;ver si hay que desplazar el mapa
	ld de,jugadorY
	ld hl,mapaY
	ld a,(de)
	sub (hl)			;mapaY-jugadorY
	cp 3
	 ret nc
	ld hl,mapaYOff
	ld a,(hl)
	sub b
	ld (hl),a
	 ret nc
	add a,8
	ld (hl),a
	ld de,mapaY
	ld a,(de)
	or a
	 jr nz,$+4
		ld (hl),a
		ret
	ex de,hl
	dec (hl)
	ret

;a = offset en bytes desde el sprite
verColisionY:
	ld hl,jugadorY
	add a,(hl)			;jugadorY + offset
	ld l,a				;hl = posición Y donde queremos buscar en el mapa
	ld h,0				;...
	ld e,l				;ld de,hl
	ld d,h				;...
	add hl,hl
	add hl,de
	add hl,hl			;x6
	ld de,(mapa)		;dirección del mapa
	add hl,de			;mapa + posición Y
	ld a,(jugadorX)
	ld b,a				;guardar jugadorX
	call aDiv8			;a = a/8
	ld e,a
	ld d,0
	add hl,de			;mapa + posición X
	ld a,(hl)
	call getByteAccion
	ld c,a
;si no está alineado, hay que verificar otra baldosa
	ld a,b
	and $7
	 ret z
	inc hl
	ld a,(hl)
	jp getByteAccion

verColisionX:
	ld hl,jugadorY
	ld l,(hl)			;ld hl,(hl)
	ld h,0				;...
	ld a,(jugadorYOff)
	add a,4				;no buscar colisiones en la parte más alta del sprite
	bit 3,a
	 jr z,$+3
		inc l
	ld e,l				;ld de,hl
	ld d,h				;...
	add hl,hl
	add hl,de
	add hl,hl			;x6
	ld de,(mapa)		;dirección del mapa
	add hl,de			;mapa + posición Y

	ld a,(jugadorX)
	add a,b				;guardar jugadorX
	call aDiv8			;a = a/8
	ld e,a
	ld d,0
	add hl,de			;mapa + posición X
	ld a,(hl)
	call getByteAccion	;pone el byte de acción en a
	ld c,a
	ld a,(jugadorYOff)
	cp 4
	ld a,c
	 ret z
;si no está alineado, hay que verificar otra baldosa más
	ld e,6
	add hl,de
	ld a,(hl)
	 call nz,getByteAccion
	or c
	ret

getByteAccion:
	push hl
		call getBrush
		inc hl			;saltar el byte que contiene el sprite id
		ld a,(hl)		;byte de acciones
	pop hl
	ret

aDiv8:
	rra
	rra
	rra
	and $1F
	ret

dibMapa:
	ld hl,(mapa)
mapaY = $+1
	ld a,$00
	ld b,a
	add a,a
	add a,b
	ld e,a
	ld d,0
	add hl,de
	add hl,de
	exx
		ld de,12
		ld hl,gbuf
		ld c,9
dibMapa_fila:
		ld b,6
dibMapa_bucle:
		push hl					;guardar el lugar en el gbuf
	exx
	push hl						;nuestro lugar en el tilemap
	ld a,(hl)					;id del brush
	call getBrush
	ld a,(hl)
	add a,a
	add a,a
	add a,a						;x8
	ld e,a
	ld d,0
	ld hl,sprite_data
	add hl,de
	ld b,8
dibMapa_sprite:
	ld a,(hl)
	inc hl						;leer el byte y avanzar hl al próximo
	exx
		ld (hl),a				;hl' = gbuf
		add hl,de				;avanzar a la próxima fila
	exx
	djnz dibMapa_sprite
	pop hl						;tilemap+1
	inc hl
	exx
		pop hl					;gbuf+1
		inc hl
		djnz dibMapa_bucle
;la fila ha sido completada, ahora la próxima
		ld e,7*12+6				;cada baldosa = 8 pixeles. normalmente sería 7*12
		add hl,de				;+6 porque sólo utilizamos la mitad de la pantalla
		ld e,12		
		dec c
		jr nz,dibMapa_fila
	ret

getBrush:
	ld hl,brush_tabla
	ld e,a
	ld d,0
	add hl,de
	ld e,(hl)
	ld hl,brush_data
	add hl,de
	ret

buscarAcciones:
	ld a,(jugadorYOff)
	cp 4
	 ret nz
	ld a,(jugadorX)
	ld b,a
	and $7
	 ret nz				;hay que estar alineadx
	ld a,b
	ld hl,jugadorY
	ld l,(hl)			;ld hl,(hl)
	inc l
	ld h,0				;...
	ld e,l				;ld de,hl
	ld d,h				;...
	add hl,hl
	add hl,de
	add hl,hl			;x6
	ld de,(mapa)		;dirección del mapa
	add hl,de			;mapa + posición Y
	call aDiv8			;a = a/8
	ld e,a
	ld d,0
	add hl,de			;mapa + posición X
	ld a,(hl)
	call getByteAccion	;pone el byte de acción en a
	bit 4,a				;bit 3 = avanzar de nivel
	 ret z
	bcall(_grBufClr)
	jp avanzarNivel
