;No me atreveré a hablar en la madrugada
;Y odiaré vuestros ojos hasta el ultimo momento de la muerte
;El compañero que me recuerde sabrá el dolor siniestro de las prisiones fascistas.
;Sabrá de vuestras palabras opresoras y crueles.
;Me asesinaréis por la mañana a escondidas y temerosos.
;Porque sabéis que mi nombre no lo envolverá el silencio, porque sabéis que mi sueño no lo apagaréis.
;Esta libertad que labio a labio, paso a paso, poco a poco, os corta el paso.
;-Salvador Puig Antich

;entrada:	ahl = número para convertir
;salida:	 hl = pointer al string
num2String_no_ceros:
	call num2String
	ld c,-1		 ;this part here removes the leading 0s
	push hl
		ld a,(hl)
		inc c
		inc hl
		or a			;ten ($0A) is the value of 0 in my alphabet (i think ASCII uses $30?)
		jr z,$-4		;repeat until we find a non-zero number
		ld de,table
		ld l,e
		ld h,d			;ld hl,numberString
		ld b,0			;bc=# of leading 0s
		add hl,bc		;hl points to first non-zero character
		ld a,7			;string = 6 bytes, 5 characters + EOS byte
		sub c
		ld c,a			;bc = number of non-zero bytes
		ldir			;essentially, for every 0, shift the number left one.
	pop hl
	ret

num2String:
	exx
		ld hl,table	;for the ldi in dN_b2dloop
	exx
	ld de,50000		;subtracted 2x so = -100,000
	call bigNum_2d
	ld de,-10000		;x2 = -10,000
	call dN_b2d
	ld de,-1000	 ;check how many 1,000s units there are
	call dN_b2d
	ld de,-100		;hundreds
	call dN_b2d
	ld de,-10		;tens
	call dN_b2d
	ld de,-1		;single digits
	call dN_b2d
	exx
	ld (hl),$FF
	ld hl,table	;where the string is stored
	ret

bigNum_2d:
	ld c,-1		 ;if there is no carry the first run through, # = 0
bN2d_loop:
	inc c			;each iteration increase accumulator by 1
	sbc ahl,de
	or a
	sbc ahl,de
	or a
	jp p,bN2d_loop
	add ahl,de		;225 - 100 = 125 - 100 = 25 - 100 = -75. This adds 100 again so we can check the next digits.
	add ahl,de		;225 - 100 = 125 - 100 = 25 - 100 = -75. This adds 100 again so we can check the next digits.

	push bc
	exx
	pop bc
		ld (hl),c
		inc hl
	exx
	ret

dN_b2d:
	ld a,-1					;if there is no carry the first run through, # = 0
dN_b2dloop:
	inc a					;each iteration increase accumulator by 1
	add hl,de
	jr c,dN_b2dloop
	or a
	sbc hl,de				;225 - 100 = 125 - 100 = 25 - 100 = -75. This adds 100 again so we can check the next digits.
	exx
		ld (hl),a
		inc hl
	exx
	ret

dibTiempo:
	ld hl,tiempoSprite		;sprite
	ld de,gbuf+(1*12)+8		;lugar en el gbuf
	ld bc,$020A				;b = cuantos bytes queremos borrar después de dibujar el sprite
	call dibPalabra			;c = cuantos pixeles hacen falta para alinearlo en la próxima fila, +2
	ld hl,(tiempo)
	ld de,-4
	add hl,de
	ld a,l
	or h
	 ret z
	ld (tiempo),hl
	ld de,(1*256)+75
dibTiempo_var:
	ld (penCol),de
	ld hl,(tiempo)
	xor a
	ld l,h					;sólo nos importa el MSB
	ld h,0
	call num2String_no_ceros
	jp dibNumero

dibPuntos:
	ld hl,puntosSprite
	ld de,gbuf+(60*12)+7
	ld bc,$0309
	call dibPalabra
	ld de,(60*256)+65
dibPuntos_var:
	ld (penCol),de
	ld hl,(meterPuntos)
	ld a,l
	or h
	 jr z,noAnadirPuntos
	dec hl
	ld (meterPuntos),hl
;añadir un punto!
	ld bc,1
	ld hl,(puntos)
	ld a,(puntos+2)
	add ahl,bc
	ld (puntos+2),a
	ld (puntos),hl
noAnadirPuntos:
;convertir puntos
	ld hl,(puntos)
	ld a,(puntos+2)
	call num2String
;dibujarlos
	jp dibNumero

;hl = sprite para dibujar
;de = lugar en gbuf donde copiar el sprite
;b = número de bytes que borrar después del sprite
;c = número de bytes para llegar hasta la próxima fila +2 (por los dos ldi)
dibPalabra:
	ld a,4			;sprites tienen una altura de 4 pixeles
dibPuntosBucle:
	push bc
		ldi			;copiar sprite al gbuf
		ldi
		ex de,hl	;<-
		ld (hl),0	;  |
		inc hl		;  |
		 djnz $-3	;  |
		add hl,bc	;  |
	pop bc			;  |
	ex de,hl		;<-
	dec a
	 jr nz,dibPuntosBucle
	ret

dibNivel:
	ld ix,nivelSprite	;sprite
	ld a,50				;x
	ld e,1				;y
	ld b,4				;altura del sprite
	call dibSprite_var
	ld hl,(nivelActual)
	xor a
	ld h,a
	call num2String_no_ceros

	ld de,(1*256)+55
	ld (penCol),de
dibNumero:
	ld a,(hl)
	add a,a
	add a,a
	 ret m
	ld c,a
	ld b,0
	push hl
	ld hl,penCol
	ld a,(hl)
	add a,4
	ld (hl),a
	inc hl
	ld e,(hl)	
	ld ix,numeros
	add ix,bc
	ld b,4				;altura del sprite
	call dibSprite_var
	pop hl
	inc hl
	jr dibNumero
